"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const unified_1 = __importDefault(require("unified"));
const unist_util_modify_children_1 = __importDefault(require("unist-util-modify-children"));
// FIXME: Type.
const hastUtilToText = require("hast-util-to-text");
const rehype_parse_1 = __importDefault(require("rehype-parse"));
const html_1 = __importDefault(require("@leafac/html"));
const attacher = ({ highlighter, throwOnUnsupportedLanguage = false }) => (tree) => {
    unist_util_modify_children_1.default((node, index, parent) => {
        if (node.tagName === "pre" &&
            Array.isArray(node.children) &&
            node.children.length === 1 &&
            node.children[0].tagName === "code" &&
            typeof node.children[0].properties === "object" &&
            Array.isArray(node.children[0].properties.className) &&
            typeof node.children[0].properties.className[0] === "string" &&
            node.children[0].properties.className[0].startsWith("language-")) {
            const code = hastUtilToText(node);
            const language = node.children[0].properties.className[0].slice("language-".length);
            let output;
            try {
                if (typeof highlighter.codeToHtml === "function")
                    output = highlighter.codeToHtml(code, language);
                else
                    output = html_1.default `
            <div class="rehype-shiki">
              $${Object.entries(highlighter).map(([name, highlighter]) => html_1.default `
                    <div class="${name}">
                      $${highlighter.codeToHtml(code, language)}
                    </div>
                  `)}
            </div>
          `;
            }
            catch (error) {
                if (throwOnUnsupportedLanguage)
                    throw error;
                else
                    return;
            }
            parent.children[index] = hastParser.parse(output);
        }
    })(tree);
};
const hastParser = unified_1.default().use(rehype_parse_1.default, { fragment: true });
exports.default = attacher;
//# sourceMappingURL=index.js.map